using System;

/// @author  Vesa Lappalainen
/// @version 23.10.2012
///
/// <summary>
/// Tutkitaan matriiseja
/// </summary>
public class Matriisit
{
    /// <summary>
    /// Tutkitaan matriiseja
    /// </summary>
    /// <param name="args">ei käytössä</param>
    public static void Main(string[] args)
    {
        int[,] mat = {
            {2,1,2},
            {3,4,2},
            {1,0,1},
            {1,8,9}
        };
        // int[,] mat2 = new int[6, 5];
        // mat[0, 0] = 2;

        int lkm = MonellakoRivilla(mat, 5);
        Console.WriteLine(lkm);
    }


    /// <summary>
    /// Lasketaan monellako rivillä taulukossa esiintyy etsittävä luku.
    /// Jos luku on useasti samalla rivillä, rivi lasketaan yhden kerran.
    /// </summary>
    /// <param name="mat">matriisi, josta lukua etsitään</param>
    /// <param name="etsittava">luku jota etsitään</param>
    /// <returns>monellako rivillä etsittävä oli</returns>
    /// <example>
    /// <pre name="test">
    ///  int[,] t = { {2,1,2},
    ///               {3,4,2},
    ///               {1,0,1},
    ///               {1,8,9} };
    ///  MonellakoRivilla(t,2) === 2;
    ///  MonellakoRivilla(t,5) === 0;
    ///  MonellakoRivilla(t,0) === 1;
    ///  MonellakoRivilla(t,1) === 3;
    ///  MonellakoRivilla(new int[0,0],1) === 0;
    /// </pre>
    /// </example>
    public static int MonellakoRivilla(int[,] mat, int etsittava)
    {
        int riveja = mat.GetLength(0);
        int sarakkeita = mat.GetLength(1);

        int lkm = 0;
        for (int iy = 0; iy < riveja; iy++)
        {
            for (int ix = 0; ix < sarakkeita; ix++)
            {
                int luku = mat[iy, ix];
                if (luku == etsittava)
                {
                    lkm++;
                    break;
                }
            }
        }
        
        return lkm;
    }
    
}